//
// main.cpp - smplcalc2vÕC
//
#include <iostream>
#include <stack>     // stackg
#include <cmath>     // atof()̂
#include <cstdlib>   // atof()̂
#include <cctype>    // isdigit()̂
#include "util.h"

using namespace std;

enum tokenType { Value, Plus, Minus, Mult, Divide, LParen, RParen };
typedef tokenType TokenType;

class Token {
    double value;
    TokenType type;
public:
    // RXgN^
    Token () {};
    Token (double v, TokenType t) {
        value = v;
        type = t;
    };
    Token (double v) {
        value = v;
        type = Value;
    };
    Token (TokenType t) {
        value = 0.0;
        type = t;
    };
    double getValue() { return value; };
    TokenType getType() { return type; };
};

int getTop2Elem(stack<Token> &, Token *, Token *);
void printstack(stack<Token>);
int isNumberString(string );
void syntaxError();
int processRParen(stack<Token> & );

int main(int argc, char *argv[])
{
    stack<Token> stck;
    Token top, top_1;
    string s;
    double a, b;

    while (true)
    {
        cout << "->";  // vvgo͂
        cin >> s;      // [U[̃L[͂󂯎
        if ( s.length() == 0) // s̓G[Ƃ݂ȂȂ
            continue;
        // 񂪁uquitvł΃[v𔲂
        if ( compareIgnCase(s, "quit") )
            break;
        // uprintstackvłΌ݂̃X^bN̓eo͂
        if ( compareIgnCase(s, "printstack") || compareIgnCase(s, "ps")) {
            printstack(stck);
            continue;
        }

        char c = s[0];      // ̐擪̕o
        if (s.size() == 1 &&  !isdigit((int)c)) { // ZqƂ݂Ȃ
            switch(c) {
            case '+': // Z
                stck.push( Token (Plus));
                break;
            case '-': // Z
                stck.push( Token (Minus));
                break;
            case '*': // Z
                stck.push( Token (Mult));
               break;
            case '/':  // ZiZj
                stck.push( Token (Divide));
                break;
            case '(':  // (
                stck.push( Token (LParen));
                break;
            case ')':  // E)
                processRParen(stck);
                break;
            default:
                // +A-A/A*̂łȂ΃G[Ƃ݂Ȃ
                syntaxError();
                break;
            }
            continue;
        } // fi
        // l͂ꂽׂ
        if ( isNumberString(s) ) {
            if (stck.size() < 2) {
                // lX^bNɃvbV
                stck.push( Token(atof(s.c_str())) );
            } else { 
                // X^bN̓̗vfo
                getTop2Elem(stck, &top, &top_1);
                TokenType tt = top.getType();
                if (tt > Value && tt < LParen) {// Zq
                    tt = top_1.getType();
                    if (tt == Value) {// Z
                        a = atof(s.c_str());
                        b = top_1.getValue();
                        switch (top.getType()) {
                        case Plus: // Z
                            cout << a + b << endl;
                            stck.push( Token ( a + b ) );
                            break;
                        case Minus: // Z
                            cout << b - a << endl;
                            stck.push( Token ( b - a ) );
                            break;
                        case Mult: // Z
                            cout << a * b << endl;
                            stck.push( Token ( a * b ) );
                            break;
                        case Divide:  // ZiZj
                            cout << b / a << endl;
                            stck.push( Token ( b / a ) );
                            break;
                        default:
                            // +A-A/A*̂łȂ΃G[Ƃ݂Ȃ
                            syntaxError();
                            break;
                        }  // hctiws
                    }// fi
                } else // fi
                if (tt == LParen) {// (
                    stck.push( top_1 );
                    stck.push( top );
                    stck.push( Token ( atof(s.c_str()) ) );
                } else {
                    syntaxError();
                    stck.push(top_1);
                    stck.push(top);
                }
            }// fi
        } else { 
            syntaxError();
        }
    }
    
    return 0;
}

// Eʂ̏
int processRParen(stack<Token> &stck)
{
    int n = stck.size();
    if (n < 4){
        double v = stck.top().getValue();
        cout << v << endl;
        for (int i=0; i<n; i++)
            stck.pop();
        stck.push( Token(v) );
        return 0;
    }
    // X^bN̂S̗vfo
    Token top, top_1, top_2, top_3;
    getTop2Elem(stck, &top, &top_1);
    getTop2Elem(stck, &top_2, &top_3);
    double a = top.getValue();
    double b = top_3.getValue();
    TokenType tt = top_2.getType();
    switch (tt) {
        case Plus: // Z
            cout << a + b << endl;
            stck.push( Token ( a + b ) );
            break;
        case Minus: // Z
            cout << b - a << endl;
            stck.push( Token ( b - a ) );
            break;
        case Mult: // Z
            cout << a * b << endl;
            stck.push( Token ( a * b ) );
            break;
        case Divide:  // ZiZj
            cout << b / a << endl;
            stck.push( Token ( b / a ) );
            break;
        default:
            // +A-A/A*̂łȂ΃G[Ƃ݂Ȃ
            syntaxError();
            break;
    }  // hctiws
    return 0;
}

// X^bNŏ㕔̗vfo
int getTop2Elem(stack<Token> &stck, Token *a, Token *b)
{
    if (stck.size() < 2) {
        cout << "Iyh܂" << endl;
        return -1;
    }
    *a = stck.top();
    stck.pop();
    *b = stck.top();
    stck.pop();

    return 0;
}

string TokenTypeName[] = { "Value", "Plus", "Minus", "Mult", "Divide",
                           "LParen", "RParen" };

// X^bN̓eׂďo͂
void printstack(stack<Token> stck)
{
    stack<Token> tmpstck; // X^bN̓eo͂ۂɃf[^
                           // ꎞIɕۑ邽߂̕ϐ
    tmpstck = stck;
    cout << "---  stack top   ---" << endl;
    int n = (int)tmpstck.size();
    for(int i=0; i<n; i++) {
        Token t = tmpstck.top();
        cout << TokenTypeName[t.getType()] << ":" << t.getValue() << endl;
        tmpstck.pop();
    }
    cout << "--- stack bottom ---" << endl;
}

