// 
// gettoken.h
//
#ifndef GETTOKEN_H
#define GETTOKEN_H
#include <iostream>
#include <algorithm>
#include <string>
#include <cctype>
#include <stack>

using namespace std;

typedef enum tokenType { Value, Plus, Minus, Mult, Divide, Assign,
                 LParen, RParen, Symbol, Variable, Invalid, Start } TokenType;

class Token {
    string symbol;
    double value;
    TokenType type;

public:
    // RXgN^
    Token () {};
    Token (TokenType t, string s, double v) {
        symbol = s;
        type = t;
        value = v;
    };
    Token (TokenType t, double v) {
        type = t;
        value = v;
    };
    Token (double v) {
        value = v;
        type = Value;
    };
    Token (string s) {
        symbol = s;
        type = Symbol;
        value = 0;
    };
    Token (TokenType t) {
        value = 0.0;
        type = t;
    };
    string getSymbol() { return symbol; };
    double getValue() { return value; };
    TokenType getType() { return type; };
    bool isStartToken();
    void printToken();
};

Token *getToken(string s);
bool isStartToken(TokenType tt);

extern Token prevTok;
extern bool disptoken;   // falseɂƃg[N\Ȃ
#endif
