//
// interpret.cpp
//
#include "gettoken.h"
#include "interpret.h"
#include "util.h"

map <string, double> varmap; // ϐ\

int interpret()
{
    Token current = stck.top();
    TokenType tt = current.getType();
    double value = current.getValue();
    string symbol = current.getSymbol();

    printstack( dispstack );

    if (tt == Symbol) {    // R}hϐ
        stck.pop();
        if ( compareIgnCase(symbol, "print") ) { // printR}h
            return 0; // printR}h͖
        }
        // ϐƂ݂Ȃ
        map <string, double>::iterator itr;
        itr = varmap.find(symbol);
        if (itr == varmap.end() ){ // ϐ͓o^ĂȂ
            varmap[symbol] = 0.0;
            if (stck.size() == 0) {
                stck.push( Token(Variable, symbol, 0) );
                return 0;
            } else {
                stck.push( Token(0.0) );
            }
        } else {
            double v = itr->second; // ϐ̒l
            if (stck.size() == 0) {
                stck.push( Token(Variable, symbol, v) );
                return 0;
            } else
                stck.push( Token(v) );
        }
        current = stck.top();
        tt = current.getType();
        value = current.getValue();
        symbol = current.getSymbol();
        printstack( dispstack );
    }

    if (Value < tt && tt < Symbol) { // Zq
        if (tt == RParen)  // E)
            processRParen(stck);
        return 0;
    } // fi

    // l͂ꂽׂ
    if ( tt == Value || tt == Variable) {
        stck.pop();
        Token top, top_1;
        double a, b;
        if (stck.size() < 2) { 
            // lX^bNɃvbVB
            stck.push( current );
        } else { 
            // X^bN̓̗vfo
            getTop2Elem(stck, &top, &top_1);
            tt = top.getType();
            if (tt == Assign) {       // =Zq
                stck.push(top_1);
                stck.push(top);
                stck.push(current);
                return 0;
            }
            if (tt > Value && tt < LParen) { // Zq
                tt = top_1.getType();
                if (tt == Value || tt == Variable) {// Z
                    a = value;
                    b = top_1.getValue();
                    switch (top.getType()) {
                        case Plus: // Z
                            stck.push( Token ( a + b ) );
                            break;
                        case Minus: // Z
                            stck.push( Token ( b - a ) );
                            break;
                        case Mult: // Z
                            stck.push( Token ( a * b ) );
                            break;
                        case Divide:  // ZiZj
                            stck.push( Token ( b / a ) );
                            break;
                        default:
                            // +A-A/A*̂łȂ΃G[Ƃ݂Ȃ
                            syntaxError();
                            break;
                    }  // hctiws
                }// fi
            }// fi
            if (tt == LParen) {// (
                stck.push( top_1 );
                stck.push( top );
                stck.push( Token ( value ) );
            }
        }// fi
        return 0;
    } else 
        syntaxError();

    return 0; 
}

// Eʂ̏
int processRParen(stack<Token> &stck)
{
    stck.pop(); // Token current
    int n = stck.size();
    if (n < 4){
        double v = stck.top().getValue();
        for (int i=0; i<n; i++)
            stck.pop();
        stck.push( Token(v) );
        return 0;
    }
    // X^bN̂S̗vfo
    Token top, top_1, top_2, top_3;
    getTop2Elem(stck, &top, &top_1);
    getTop2Elem(stck, &top_2, &top_3);
    double a = top.getValue();
    double b = top_3.getValue();
    TokenType tt = top_2.getType();
    switch (tt) {
        case Plus: // Z
            stck.push( Token ( a + b ) );
            break;
        case Minus: // Z
            stck.push( Token ( b - a ) );
            break;
        case Mult: // Z
            stck.push( Token ( a * b ) );
            break;
        case Divide:  // ZiZj
            stck.push( Token ( b / a ) );
            break;
        default:
            // +A-A/A*̂łȂ΃G[Ƃ݂Ȃ
            syntaxError();
            break;
    }  // hctiws
    return 0;
}

// iR}hƂ݂Ȃj
int processAssign()
{
    printstack( dispstack );

    Token current = stck.top();
    stck.pop();
    double value = current.getValue(); // Value
    Token top, top_1;
    // X^bN̓̗vfo
    getTop2Elem(stck, &top, &top_1);
    TokenType tt = top.getType();  // Assign
    string symbol = top_1.getSymbol();
    if (tt == Assign && top_1.getType() == Variable) {
        varmap[symbol] = value;
    }
    else 
        syntaxError();

    return 0;
}


// X^bNŏ㕔̗vfoB
int getTop2Elem(stack<Token> &stck, Token *a, Token *b)
{
    if (stck.size() < 2) {
        cout << "Iyh܂" << endl;
        return -1;
    }
    *a = stck.top();
    stck.pop();
    *b = stck.top();
    stck.pop();

    return 0;
}

// X^bN̓eׂďo͂B
void printstack(bool print)
{
    if (!print)
        return ;

    stack<Token> tmpstck; // X^bN̓eo͂ۂɃf[^
                           // ꎞIɕۑ邽߂̕ϐB
    tmpstck = stck;
    cout << "---  stack top   ---" << endl;
    int n = (int)tmpstck.size();
    for(int i=0; i<n; i++) {
        Token t = tmpstck.top();
        TokenType tt = t.getType();
        if (tt == Variable)
            cout << TokenTypeName[t.getType()] << "(" << t.getSymbol() 
                 << ")" << t.getValue() << endl;
        else if (tt == Symbol)
            cout << TokenTypeName[t.getType()] << ":" << t.getSymbol() << endl;
        else
            cout << TokenTypeName[t.getType()] << ":" << t.getValue() << endl;
        tmpstck.pop();
    }
    cout << "--- stack bottom ---" << endl;
}

// ϐ\̓eׂďo͂B
void printvarmap( )
{
    map <string, double>::iterator itr;
    for (itr = varmap.begin(); itr != varmap.end(); itr++)
        cout << itr->first << ":" << itr->second << endl;
}
